# Konfigurationsparameter
$serverName = "HOSTNAME\INSTANZ" # z.B. "localhost\LOGINventory"
$databaseName = "DATABASENAME" # z.B. "LOGINvenotry9"
$userName = "sa"
$password = "LOGINventory6"
$destinationFolder = "C:\temp\LOGINventory-Export" # z.B. "C:\temp"
 
# Sicher stellen, dass der Zielordner existiert
if (-not (Test-Path $destinationFolder)) {
    New-Item -Path $destinationFolder -ItemType Directory
}
 
# SQL Server Verbindung aufbauen
$connectionString = "Server=$serverName;Database=$databaseName;User Id=$userName;Password=$password;"
$connection = New-Object System.Data.SqlClient.SqlConnection
$connection.ConnectionString = $connectionString
 
# Abfrage, um Dateien aus der Tabelle zu holen
$query = "SELECT [Name], [Type], [File] FROM [dbo].[ExternalResource] WHERE [File] IS NOT NULL"
 
$command = $connection.CreateCommand()
$command.CommandText = $query
 
try {
    $connection.Open()
    $reader = $command.ExecuteReader()
 
    while ($reader.Read()) {     
		$fileName = $reader["Name"]     
		$fileType = $reader["Type"]     
		$fileData = $reader["File"]     
		# Dateipfad erstellen     
		$completeFilePath = Join-Path -Path $destinationFolder -ChildPath "$fileName.$fileType"     
		# Überprüfen, ob die Datei bereits existiert     
		$counter = 1     
		while (Test-Path $completeFilePath) {         
			$completeFilePath = Join-Path -Path $destinationFolder -ChildPath "$fileName($counter).$fileType"         
			$counter++     
		}     
		# Datei auf die Festplatte schreiben     
		[System.IO.File]::WriteAllBytes($completeFilePath, $fileData) 
	}
}
catch {
    Write-Error $_.Exception.Message
}
finally {
    $connection.Close()
}